import gtk, gobject, StringIO, Image, ImageDraw, ImageFont

class StatusImage:
	def __init__(self):
		self.font = ImageFont.truetype("DejaVuLGCSans-Bold.ttf", 24)
		self.width = 0
		self.height = 0
		self.text = ''
		self.logo = ''
	
	def draw(self, drawingarea, text = '', logo = 'logo.jpg'):
		x, y, width, height = drawingarea.get_allocation()
		if self.logo == logo and self.text == text:
			if self.width == width and self.height == height:
				if hasattr(self, 'pixbuf'):
					self.showimg(drawingarea, self.pixbuf)
					return
		self.width = width
		self.height = height
		self.logo = logo
		self.text = text
		pil_image = Image.open(logo)
		im = pil_image.resize((width, height), Image.NEAREST)
		draw = ImageDraw.Draw(im)
		if type(text) == str or type(text) == unicode:
			tw, th = draw.textsize(text, font=self.font)
			draw.text(((width-tw)/2, height-50), text, font=self.font)
		elif type(text) == list:
			row = 0
			for x in text:
				tw, th = draw.textsize(x, font=self.font)
				draw.text(((width-tw)/2, row*th+50), x, font=self.font)
				row += 1
		self.pixbuf = self.Image2pixbuf(im)
		tmout = gobject.timeout_add(110, self.showimg, drawingarea, self.pixbuf)
		
	def showimg(self, drawingarea, pixbuf):
		gc = drawingarea.window.new_gc()
		drawingarea.window.draw_pixbuf(gc, pixbuf, 0, 0, 0, 0, -1, -1, gtk.gdk.RGB_DITHER_NONE, 0, 0)
		return False

	def Image2pixbuf(self, image):
		file = StringIO.StringIO()
		image.save(file, 'png')
		contents = file.getvalue()
		file.close()
		loader = gtk.gdk.PixbufLoader ('png')
		loader.write (contents, len (contents))
		pixbuf = loader.get_pixbuf ()
		loader.close ()
		return pixbuf